/*
*	SmallBasic LIBRARY
*
*	2000-05-27, Nicholas Christopoulos
*
*	This program is distributed under the terms of the GPL v2.0 or later
*	Download the GNU Public License (GPL) from www.gnu.org
*/

#if !defined(_blib_h)
#define _blib_h

#include "sys.h"
#include "var.h"

#if defined(__cplusplus)
extern "C" {
#endif

void	dump_stack(void) SEC(TRASH);

// first class
void	cmd_udp(int)		SEC(BLIB);
void	cmd_udpret(void)	SEC(BLIB);
void	cmd_crvar(void)		SEC(BLIB);
void	cmd_param(void)		SEC(BLIB);
void	cmd_exit(void)		SEC(BLIB);

void	cmd_let(int);
void	cmd_dim(void);
void	cmd_erase(void);
void	cmd_print(void)		SEC(BLIB);
void	logprint_var(var_t *var) SEC(TRASH);
void	cmd_logprint(void)	SEC(TRASH);
void	cmd_input(void)		SEC(BLIB);
void	cmd_if(void)		SEC(BLIB);
void	cmd_else(void)		SEC(BLIB);
void	cmd_elif(void)		SEC(BLIB);
void	cmd_for(void)		SEC(BLIB);
void	cmd_next(void)		SEC(BLIB);
void	cmd_while(void)		SEC(BLIB);
void	cmd_wend(void)		SEC(BLIB);
void	cmd_until(void)		SEC(BLIB);
void	cmd_gosub(void)		SEC(BLIB);
void	cmd_return(void)	SEC(BLIB);
void	cmd_on_go(void)		SEC(BLIB);
void	cmd_read(void)		SEC(BLIB);
void	cmd_data(void)		SEC(BLIB);
void	cmd_restore(void)	SEC(TRASH);

void	cmd_chain(void)					SEC(BLIB);
void	cmd_run(void)					SEC(BLIB);

double	cmd_math1(byte funcCode, var_t *arg)			SEC(BMATH);
long	cmd_imath1(byte funcCode, var_t *arg)			SEC(BMATH);
void	cmd_str1(byte funcCode, var_t *arg, var_t *r)	SEC(BMATH);
void	cmd_ns1(byte funcCode, var_t *arg, var_t *r)	SEC(BMATH);
void	cmd_str0(byte funcCode, var_t *r)				SEC(BMATH);
void	cmd_wsplit()					SEC(BLIB);

// not basic, but speed is needed
void	graph_reset(void)				SEC(BLIB);	// graphics module - reset
void	cmd_pset(void)					SEC(BLIB);
void	cmd_line(void)					SEC(BLIB);
void	cmd_rect(void)					SEC(BLIB);
void	cmd_circle(void)				SEC(BLIB);
void	cmd_arc(void)					SEC(BLIB);
char	*draw_getval(const char *src, int *c) SEC(BIO);
void	cmd_draw(void)					SEC(BLIB);
void	cmd_pen(void)					SEC(BLIB);
void	cmd_chart_fstr(double v, char *buf) SEC(BLIB);
void	cmd_chart(void)					SEC(BLIB);
void	cmd_drawpoly(void)				SEC(BLIB);

// third class
void	cmd_strN(byte,var_t*)			SEC(BMATH);		// its ok, i want all functions to BMATH
void	cmd_intN(byte,var_t*)			SEC(BMATH);
void	cmd_numN(byte,var_t*)			SEC(BMATH);
void	cmd_genfunc(byte,var_t*) 		SEC(BMATH);

void	cmd_randomize(void)				SEC(BIO);
void	cmd_at(void)					SEC(BIO);
void	cmd_locate(void)				SEC(BIO);
void	cmd_color(void)					SEC(BIO);

void	cmd_beep(void)					SEC(BIO);
void	cmd_sound(void)					SEC(BIO);
void	cmd_play_reset(void)			SEC(BIO);
void	cmd_play(void)					SEC(BIO);
void	cmd_pause(void)					SEC(BIO);
void	cmd_delay(void)		;

// FILE I/O
void	cmd_fopen(void)					SEC(BIO);
void	cmd_fclose(void)				SEC(BIO);
void	cmd_fprint(void)				SEC(BIO);
void	cmd_finput(void)				SEC(BIO);
void	cmd_flineinput(void)			SEC(BIO);
void	cmd_fkill(void)					SEC(BIO);
void	cmd_fseek(void)					SEC(BIO);
void	cmd_filecp(int mv)				SEC(BIO);

#ifdef BC_DEBUG
void	cmd_bcdump() 					SEC(TRASH);
#endif

#if defined(__cplusplus)
}
#endif

#endif

