/*
*	low-level platform driver
*
*	ndc: 2001-02-13
*/

#if !defined(_palm_dev_h)
#define _palm_dev_h

#if defined(__cplusplus)
extern "C" {
#endif

#if defined(USE_SVGALIB)
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <vgakeyboard.h>
#endif

#if defined(USE_OFBIS)
#include <ofbis.h>
#endif

int		osd_devinit(void)												SEC(BIO);
int		osd_devrestore(void)											SEC(BIO);

int		osd_events(int wait_flag);

void	osd_cls(void)													SEC(BIO);
void	osd_setxy(int x, int y)											SEC(BIO);
int		osd_getx(void)													SEC(BIO);
int		osd_gety(void)													SEC(BIO);
void	osd_settextcolor(int fg, int bg) 								SEC(BIO);

int		osd_textwidth(const char *str)									SEC(BIO);
int		osd_textheight(const char *str)									SEC(BIO);

void	osd_setpenmode(int enable)										SEC(BIO);
int		osd_getpen(int mode)											SEC(BIO);

void	osd_write(const char *str)										SEC(BIO);
char	*osd_gets(char *dest, int size)									SEC(BIO);

void	osd_setcolor(int color)											SEC(BIO);
void	osd_setpixel(int x, int y)										SEC(BIO);
void	osd_line(int x1, int y1, int x2, int y2)						SEC(BIO);
void	osd_rect(int x1, int y1, int x2, int y2, int fill)				SEC(BIO);

void	osd_beep(void)													SEC(BIO);
void	osd_sound(int frq, int dur, int vol, int bgplay)				SEC(BIO);

#if defined(__cplusplus)
}
#endif

#endif

