/*
*	Palm DOC files 
*
*	Nicholas Christopoulos
*/

#if !defined(_pdoc_h)
#define _pdoc_h

typedef struct	{
	word	version;			// 2   1:plain, 2:compressed, 3:ext
	word	reserved1;			// 2
	dword	doc_size;			// 4   in bytes, when uncompressed
	word	page_count;			// 2   numRecords-1
	word	rec_size; 			// 2	/* usually MAXTEXTSIZE */
	dword	reserved2;			// 4
	} pdoc_info_t;            

/* DOC Record in inside */
typedef struct	{
	byte	*raw;					/* Raw Text, compressed */
	byte	*cook;					/* compress/uncompress Text */
	dword	raw_len;				/* raw_len */
	dword	org_len;				/* original len, uncompress */
	} pdoc_page_t;

/* finaly the pdoc_t structure */
typedef struct	{
	pdoc_info_t	info;		// also, the header of DOCs
	pdoc_page_t	page;

	DmOpenRef	db_ref;		// file handle
	word		page_no;	// current page index (loaded into 'page')
	word		page_count;	// the number of the pages

	char*		text; 		// current page text
	dword		length;		// current page text length
	} pdoc_t;

int		pdoc_open(const char *filename, pdoc_t *doc) SEC(PDOC);
void	pdoc_close(pdoc_t *doc)						SEC(PDOC);
void	pdoc_loadpage(pdoc_t *doc, int index)		SEC(PDOC);

#endif

